#
# edge.rb
# An edge in the computed dependency graph
#

class Edge
  @@edges = Hash.new

  attr_reader :name, :from, :to
  attr_reader :reason
  attr_accessor :num

  def initialize( name, from, to, reason = nil )
STDERR.puts "Edge.new #{name}: #{from} -> #{to}" if $debug
    @name = name
    @from = from
    @to = to
    @reason = reason
    @@edges[from] = Hash.new unless @@edges.has_key? from
    @@edges[from][to] = [reason]
  end

  #
  # factory style creator
  #

  def Edge.create( name, from, to, reason = nil )
STDERR.puts "Edge.create #{name}: #{from} -> #{to}" if $debug
	return nil if from == to
	outs = @@edges[from]
	if outs
		reasons = outs[to]
		if reasons
			reasons << reason
			return nil
		end
	end
	return Edge.new( name, from, to, reason )
  end

  def to_s
    return "Edge '#{name}' (#{from.to_s} -> #{to.to_s})"
  end

end
