#
# ContentParser for 'content' style files
#

class ContentParser

	attr_reader :filename, :lnum

	#
	# ContentParser constructor
	# takes filename
	#

	def initialize( filename )
		@filename = filename
		begin	# rescue block
			@lnum = 0
			File.open( filename ) do |f|
				@f = f
				until f.eof?
					parse_line( get_line )
				end
				self.send( :finish )
			end
		rescue
			STDERR.puts "Parsing of #{@filename} failed"
			raise;
		end
	end

	# -----------------------------------------------------

	private

	def get_line
		l = ""
		loop do
			return nil if @f.eof?
			l = @f.gets.chomp
			@lnum = @lnum + 1
#puts "get_line(#{@lnum}:#{l})"
			next if l.size == 0
			next if l[0,1] == "#"
			break
		end
		return l
	end

	#
	# parse line containing a tag
	#

	def parse_line( line )
		splitpos = line.index " "
		if splitpos
			tag = line[0, splitpos]
			value = line[splitpos..-1].strip
		else
			tag = line
			value = nil
		end
		tag, @subtag = tag.split( "." )
#puts "tag[#{tag}][#{@subtag}][#{value}]"
      self.send( tag.downcase, value )
	end

end

