#
# build dependencies parser
#
# Parses .depend files from /work/built/info/depend/
#

require 'zypptools/lib/package'

class Depend
    attr_reader :packages, :patterns, :patches, :products

    def initialize( name )
	raise "Not a file '#{name}'" unless File.exists?( name )

	@packages = Hash.new

	File.open( name ).each { |depline|
	    pkg, depstring = depline.split( ":" )
	    deps = depstring.chomp.split( " " )

	    package = Package.new( pkg )
	    package.deps :requires, deps

	    @packages[pkg] = package
	}
    end

end
