require 'rexml/document'
include REXML

# class for importing patch-files

class Patch

	def initialize( file )
		@file = REXML::Document.new(File.open(file))
		@p_arch = "noarch"
		@pa_name = Array.new
		@pa_op = Array.new
		@pa_version = Array.new
		@pa_release = Array.new
		@pa_epoch = Array.new
		@a_name = Array.new
		@a_arch = Array.new
		@a_version = Array.new
		@a_release = Array.new
		@a_release = Array.new
		@af_name = Array.new
		@ar_name = Array.new
		@ar_kind = Array.new
		@ar_op = Array.new
		@ar_epoch = Array.new
		@ar_version = Array.new
		@ar_release = Array.new
		@af_kind = Array.new
		@pac_filesize = Array.new
		@pac_instsize = Array.new
		@pac_filename = Array.new

	end

	def patch
		i = 0
		@p_name = @file.elements["//yum:name"].text
		@p_version = @file.elements["//yum:version"].attributes["ver"]
		@p_release = @file.elements["//yum:version"].attributes["rel"]
		@file.elements.each("//package") do |c|
			unless @pa_name.include?(c.elements["name"].text) 
				@pa_name[i] = c.elements["name"].text
				@pa_op[i] = "EQ"
				@pa_version[i] = c.elements["version"].attributes["ver"]
				@pa_release[i] = c.elements["version"].attributes["rel"]
				@pa_epoch[i] = c.elements["version"].attributes["epoch"]
				i += 1
			end
		end
	end

	def atom
		i = 0
		@file.elements.each("patch") do |a|
		a.elements.each("atoms") do |b|
			b.elements.each("package") do |c|
				@a_name[i] = c.elements["name"].text
				@a_arch[i] = c.elements["arch"].text
				@a_version[i] = c.elements["version"].attributes["ver"]
				@a_release[i] = c.elements["version"].attributes["rel"]
				@pac_filesize[i] = c.elements["size"].attributes["package"]
				@pac_instsize[i] = c.elements["size"].attributes["installed"]
				dum, dum2, @pac_filename[i] = c.elements["location"].attributes["href"].split('/')
				c.elements.each("format") do |cc|
					cc.elements.each("rpm:requires") do |ccc|
						@ar_name[i] = ccc.elements["rpm:entry"].attributes["name"]
						@ar_kind[i] = ccc.elements["rpm:entry"].attributes["kind"]
						@ar_version[i] = ccc.elements["rpm:entry"].attributes["ver"]
						@ar_release[i] = ccc.elements["rpm:entry"].attributes["rel"]
						@ar_op[i] = ccc.elements["rpm:entry"].attributes["flags"]
						@ar_epoch[i] = ccc.elements["rpm:entry"].attributes["epoch"]
					end
					cc.elements.each("suse:freshens") do |ccc|
						@af_name[i] = ccc.elements["suse:entry"].attributes["name"]
						@af_kind[i] = ccc.elements["suse:entry"].attributes["kind"]
					end
				end
				i += 1
			end
			end
		end
	end

	def package
		i = 0
		@pac_desc = @file.elements["//description[@lang='en']"].text
		@pac_sum = @file.elements["//summary[@lang='en']"].text
		@pac_sec = @file.elements["//category"].text
		
	end

	def package_dep
				
	end
	
	attr_reader :p_arch, :p_name, :p_version, :p_release, :pa_name, :pa_op, :pa_version, :pa_release, :a_name, :a_arch, :a_version, :a_release
	attr_reader :a_location, :af_name, :ar_name, :af_kind, :ar_kind, :ar_version, :ar_release, :ar_op, :pa_epoch, :ar_epoch, :pac_desc, :pac_sum
	attr_reader :pac_filesize, :pac_instsize, :pac_filename, :pac_sec

	def get_root
		"#{@file.root.name}"
	end
		
end
