#
# pdl.rb
#
# 'pdl' (pattern definition language) file support
#

require 'zypptools/lib/pattern'
require 'zypptools/lib/dependency'

def save_if( c, name, value )
	return if value.nil?
	name.capitalize!
	if value.class == Array
		value.each do |v|
			c.print "#{name}: "
			v.to_pdl c
		end
	else
		c.puts "#{name}: #{value}"
	end
end


class Dependency
	def to_pdl( c )
		return if @name[0,7] == "rpmlib("
		out = "#{@refers.id2name}:#{@name}"
		if @op
			out += " #{@op} "
			out += "#{@epoch}:" if @epoch
			out += "#{@version}"
			out += "-#{@release}" if @release
		end
		c.puts out
	end
end

class Resolvable
	def to_pdl( c )
		c.puts "# Pattern definition file"
		c.puts "# #{to_s}"
		save_if c, "name", @name
		save_if c, "summary", @summary
		save_if c, "description", @description

		save_if c, "epoch", @epoch
		save_if c, "version", @version
		save_if c, "release", @release
		save_if c, "arch", @architecture

		save_if c, "requires", @requires
		save_if c, "provides", @provides
		save_if c, "conflicts", @conflicts
		save_if c, "obsoletes", @obsoletes
		save_if c, "suggests", @suggests
		save_if c, "enhances", @enhances
		save_if c, "supplements", @supplements
		save_if c, "recommends", @recommends

	end
end




