#
# tlp.rb
#
# Output dependency graph as .tlp format (for Tulip)
#

require "zypptools/graph/graph"

class Graph

  def to_tlp channel, with_edgelabels = true
	channel.printf "(nodes"
	num = 1
	@nodes.each_value do |node|
		node.num = num
		channel.printf " #{num}"
		num += 1
	end
	channel.puts ")"

	edges = []
	num = 1
	@nodes.each_value do |node|
		channel.puts "# Node '#{node.to_s}'"
		node.outgoing.each do |edge|
			unless edge.num
				edge.num = num
				edges << edge
				num += 1
			end
			channel.puts "(edge #{edge.num} #{edge.from.num} #{edge.to.num})"
		end
	end

	channel.puts '(property 0 string "viewLabel"'
	channel.puts '  (default "" "")'
	@nodes.each_value do |node|
		channel.puts "  (node #{node.num} \"#{node.name}\")"
	end
	edges.each do |edge|
		channel.puts "  (edge #{edge.num} \"#{edge.name}\")"
	end
	channel.puts ")"
	edges = nil

	channel.puts '(property 0 string "viewSize"'
	channel.puts '  (default "(0,0,0)" "(1,1,1)")'
	channel.puts ")"

	channel.puts '(property 0 color "viewColor"'
	channel.puts '  (default "(235,0,23,255)" "(0,0,0,0)")'
	channel.puts ")"

	channel.puts '(property 0 layout "viewLayout"'
	channel.puts '  (default "(0,0,0)" "()")'
	channel.puts ")"
  end
end
